/*
 *  ttyvaders     Textmode shoot'em up
 *  Copyright (c) 2002 Sam Hocevar <sam@zoy.org>
 *                All Rights Reserved
 *
 *  $Id$
 *
 *  This program is free software. It comes without any warranty, to
 *  the extent permitted by applicable law. You can redistribute it
 *  and/or modify it under the terms of the Do What The Fuck You Want
 *  To Public License, Version 2, as published by Sam Hocevar. See
 *  http://sam.zoy.org/wtfpl/COPYING for more details.
 */

#include "config.h"

#include <stdlib.h>

#include "common.h"

void draw_status(game *g)
{
    static char dots30[] = "------------------------------";
    static char dashes30[] = "==============================";

    /* Draw life jauge */
    caca_set_color_ansi(g->cv, CACA_DARKGRAY, CACA_BLACK);
    caca_put_str(g->cv, 4, 1, dots30);

    if(g->p->life > MAX_LIFE * 7 / 10)
    {
        caca_set_color_ansi(g->cv, CACA_GREEN, CACA_BLACK);
    }
    else if(g->p->life > MAX_LIFE * 3 / 10)
    {
        caca_set_color_ansi(g->cv, CACA_YELLOW, CACA_BLACK);
    }
    else
    {
        caca_set_color_ansi(g->cv, CACA_RED, CACA_BLACK);
    }

    caca_put_str(g->cv, 4, 1, dashes30 + (MAX_LIFE - g->p->life) * 30 / MAX_LIFE);

    caca_set_color_ansi(g->cv, CACA_WHITE, CACA_BLACK);
    caca_put_str(g->cv, 1, 1, "L |");
    caca_put_str(g->cv, 34, 1, "|");

    /* Draw weapon jauge */
    caca_set_color_ansi(g->cv, CACA_DARKGRAY, CACA_BLACK);
    caca_put_str(g->cv, 42, 1, dots30 + 10);

    if(g->p->special > MAX_SPECIAL * 9 / 10)
    {
        caca_set_color_ansi(g->cv, CACA_WHITE, CACA_BLACK);
    }
    else if(g->p->special > MAX_SPECIAL * 3 / 10)
    {
        caca_set_color_ansi(g->cv, CACA_CYAN, CACA_BLACK);
    }
    else
    {
        caca_set_color_ansi(g->cv, CACA_BLUE, CACA_BLACK);
    }

    caca_put_str(g->cv, 42, 1, dashes30 + 10
                        + (MAX_SPECIAL - g->p->special) * 20 / MAX_SPECIAL);

    caca_set_color_ansi(g->cv, CACA_WHITE, CACA_BLACK);
    caca_put_str(g->cv, 39, 1, "S |");
    caca_put_str(g->cv, 62, 1, "|");
}

