/*
 *  ttyvaders     Textmode shoot'em up
 *  Copyright (c) 2002 Sam Hocevar <sam@zoy.org>
 *                All Rights Reserved
 *
 *  $Id$
 *
 *  This program is free software. It comes without any warranty, to
 *  the extent permitted by applicable law. You can redistribute it
 *  and/or modify it under the terms of the Do What The Fuck You Want
 *  To Public License, Version 2, as published by Sam Hocevar. See
 *  http://sam.zoy.org/wtfpl/COPYING for more details.
 */

#include "config.h"

#include <stdlib.h>

#include "common.h"

caca_canvas_t *ship_sprite;

/* Init tunnel */
player * create_player(game *g)
{
    player *p = malloc(sizeof(player));
    if(p == NULL)
        exit(1);

    p->x = g->w / 2;
    p->y = g->h - 3;
    p->vx = 0;
    p->vy = 0;
    p->weapon = 0;
    p->special = MAX_SPECIAL;
    p->life = MAX_LIFE;
    p->dead = 0;

    ship_sprite = caca_create_canvas(0, 0);
    caca_import_file(ship_sprite, "data/ship.txt", "utf8");

    return p;
}

void free_player(player *p)
{
    free(p);
}

void draw_player(game *g, player *p)
{
    if(p->dead)
        return;

    caca_set_frame(ship_sprite, 0);
    caca_blit(g->cv, p->x, p->y, ship_sprite, NULL);
}

void update_player(game *g, player *p)
{
    if(p->dead)
        return;

    if(p->life <= 0)
    {
        add_explosion(g, g->ex, p->x, p->y, 0, 0, EXPLOSION_SMALL);
        p->dead = 1;
        return;
    }

    /* Update weapon stats */
    if(p->weapon)
        p->weapon--;

    if(p->special < MAX_SPECIAL)
        p->special++;

    /* Update life */
    if(p->life < MAX_LIFE)
        p->life++;

    /* Update coords */
    p->x += p->vx;

    if(p->vx < 0)
        p->vx++;
    else if(p->vx > 0)
        p->vx--;

    if(p->x < 1)
        p->x = 1;
    else if(p->x > g->w - 7)
        p->x = g->w - 7;
}

